import es
import gamethread
import time
import cmdlib
import soccer.soccer as soccerlib
from usermsg import hudhint
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Sprint Script"
info.version = soccerlib.info.version
info.basename = "soccersprint"
info.author = "chrismrulz"

sprint_length = time.strptime(soccerlib.config["Sprint"]["length"], "%M:%S")
sprint_length = int(time.strftime('%M', sprint_length)) * 60 + int(time.strftime('%S', sprint_length))
sprint_cooldown = time.strptime(soccerlib.config["Sprint"]["cooldown"], "%M:%S")
sprint_cooldown = int(time.strftime('%M', sprint_cooldown)) * 60 + int(time.strftime('%S', sprint_cooldown))
sprint_speed = int(soccerlib.config["Sprint"]["speed"])
sprint_msgs = int(soccerlib.config["Sprint"]["msgs"])
sprint_msgmode = int(soccerlib.config["Sprint"]["msgmode"])

def load():
  es.msg('#Green', 'Soccer Sprint Script On - by Toph')
  loadblock()

def unload():
  cmdlib.unregisterClientCommand('sprint')
  cmdlib.unregisterSayCommand('!sprint')
  es.msg('#Green', 'Soccer Sprint Script Off')

def es_map_start(event_var):
  loadblock()

def loadblock():
	if(es.exists('clientcommand', 'sprint') != 1):
		cmdlib.registerClientCommand('sprint', sprint, 'Makes the player sprint')
	if(es.exists('saycommand', '!sprint') != 1):
		cmdlib.registerSayCommand('!sprint', sprint, 'Makes the player sprint')

def setspeed(userid, speed):
  es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", speed)

def round_start(event_var):
  global lastroundtime
  lastroundtime = int(time.time())
  global lastsprint
  lastsprint = {}

def getmsgs(steamid):
	if(steamid not in soccerlib.players):
		return sprint_msgs
	else:
		if('sprintmsgs' not in soccerlib.players[steamid]):
			return sprint_msgs
		else:
			return soccerlib.players[steamid]['sprintmsgs']

def getmsgmode(steamid):
	if(steamid not in soccerlib.players):
		return sprint_msgmode
	else:
		if('sprintmsgmode' not in soccerlib.players[steamid]):
			return sprint_msgmode
		else:
			return soccerlib.players[steamid]['sprintmsgmode']
  
def sprintmsg(userid, steamid, time, msg):
  if(time > lastroundtime):
    usprint_msgmode = getmsgmode(steamid)
    if(usprint_msgmode == 0):
      es.menu(sprint_cooldown, userid, msg)
    elif(usprint_msgmode == 1):
      hudhint(userid, msg)
    elif(usprint_msgmode == 2):
      es.tell(userid, "#green", msg)

def sprint(userid, args):
  global lastsprint
  sprint_steamid = es.getplayersteamid(userid)
  if(lastsprint == {}):
    lastsprint[sprint_steamid] = 0
  thesprinttime = int(time.time())
  if(thesprinttime > int(lastsprint[sprint_steamid])):
    usprint_msgs = getmsgs(sprint_steamid)
    if(usprint_msgs != 0):
      sprintmsg(userid, sprint_steamid, thesprinttime, "You are now using sprint.")
    setspeed(userid, sprint_speed)
    gamethread.delayed(sprint_length, setspeed, (userid, 1))
    if(usprint_msgs == 2):
      gamethread.delayed(sprint_length, sprintmsg, (userid, sprint_steamid, thesprinttime, "Your sprint has now ended."))
    lastsprint[sprint_steamid] = (thesprinttime + sprint_cooldown)
    if(usprint_msgs != 0):
      gamethread.delayed(sprint_cooldown, sprintmsg, (userid, sprint_steamid, thesprinttime, "You can now use sprint again."))
  else:
    if(usprint_msgs != 0):
      sprintmsg(userid, sprint_steamid, thesprinttime, "You have %s seconds before you can sprint again." % int(lastsprint[sprint_steamid] - int(thesprinttime)))